import { __decorate } from 'tslib';
import { ɵɵdefineInjectable, Injectable, Component, NgModule } from '@angular/core';
import { BehaviorSubject } from 'rxjs';
import { FormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';

var ThemeService = /** @class */ (function () {
    function ThemeService() {
        var _this = this;
        var _a;
        this._theme = new BehaviorSubject(null);
        this.loadHandler = function () { return typeof localStorage !== 'undefined' ? localStorage.getItem('theme') : null; };
        this.saveHandler = function (theme) {
            if (typeof localStorage === 'undefined') {
                return;
            }
            if (theme) {
                localStorage.setItem('theme', theme);
            }
            else {
                localStorage.removeItem('theme');
            }
        };
        this._theme.next((_a = this.savedTheme) !== null && _a !== void 0 ? _a : this.detectedTheme);
        this._theme.subscribe(function (theme) {
            if (theme) {
                document.body.setAttribute('theme', theme);
            }
            else {
                document.body.removeAttribute('theme');
            }
        });
        this._theme.subscribe(function (theme) { return _this.savedTheme = theme; });
    }
    Object.defineProperty(ThemeService.prototype, "theme$", {
        get: function () {
            return this._theme;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ThemeService.prototype, "detectedTheme", {
        get: function () {
            return typeof window !== 'undefined' && window.matchMedia('(prefers-color-scheme: dark)').matches ? 'dark' : 'light';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ThemeService.prototype, "theme", {
        get: function () {
            return this._theme.getValue();
        },
        set: function (value) {
            this._theme.next(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ThemeService.prototype, "savedTheme", {
        get: function () {
            return this.loadHandler();
        },
        set: function (theme) {
            this.saveHandler(theme);
        },
        enumerable: true,
        configurable: true
    });
    ThemeService.ɵprov = ɵɵdefineInjectable({ factory: function ThemeService_Factory() { return new ThemeService(); }, token: ThemeService, providedIn: "root" });
    ThemeService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], ThemeService);
    return ThemeService;
}());

var DarkSwitchComponent = /** @class */ (function () {
    function DarkSwitchComponent(themeService) {
        this.themeService = themeService;
    }
    DarkSwitchComponent.prototype.ngOnInit = function () {
        this.theme$ = this.themeService.theme$;
    };
    DarkSwitchComponent.ctorParameters = function () { return [
        { type: ThemeService }
    ]; };
    DarkSwitchComponent = __decorate([
        Component({
            selector: 'ng-bootstrap-darkmode-switch',
            template: "<div class=\"custom-control custom-switch\">\n  <input type=\"checkbox\" class=\"custom-control-input\" id=\"darkModeSwitch\"\n         [ngModel]=\"(theme$ | async) === 'dark'\" (ngModelChange)=\"theme$.next($event ? 'dark' : 'light')\">\n  <label class=\"custom-control-label\" for=\"darkModeSwitch\">\n    Dark Mode\n  </label>\n</div>\n",
            styles: [""]
        })
    ], DarkSwitchComponent);
    return DarkSwitchComponent;
}());

var NgBootstrapDarkmodeModule = /** @class */ (function () {
    function NgBootstrapDarkmodeModule() {
    }
    NgBootstrapDarkmodeModule = __decorate([
        NgModule({
            declarations: [
                DarkSwitchComponent,
            ],
            imports: [
                CommonModule,
                FormsModule,
            ],
            exports: [
                DarkSwitchComponent,
            ]
        })
    ], NgBootstrapDarkmodeModule);
    return NgBootstrapDarkmodeModule;
}());

/*
 * Public API Surface of ng-bootstrap-darkmode
 */

/**
 * Generated bundle index. Do not edit.
 */

export { DarkSwitchComponent, NgBootstrapDarkmodeModule, ThemeService };
//# sourceMappingURL=ng-bootstrap-darkmode.js.map
